<?php

namespace Drupal\taxonomy_entity\Form;

use Drupal\taxonomy\Form\TermDeleteForm as CoreTermDeleteForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a deletion confirmation form for taxonomy term.
 */
class TermDeleteForm extends CoreTermDeleteForm {

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    /** @var \Drupal\taxonomy\VocabularyInterface $vocabulary */
    $vocabulary = $form_state->get(['taxonomy', 'vocabulary']);
    // Update the current hierarchy type as we go.
    $termStorage = $this->entityTypeManager->getStorage('taxonomy_term');
    $hierarchy = $termStorage->getVocabularyHierarchyType($vocabulary->id());

    parent::submitForm($form, $form_state);

    if ($termStorage->getVocabularyHierarchyType($vocabulary->id()) !== $hierarchy) {
      $termStorage->setVocabularyHierarchyType($vocabulary->id(), $hierarchy);
      $vocabulary->save();
    }
  }

}
